/******************************************************************************
 *                                                                            *
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *****************************************************************************
 * Originally developed and contributed by Ittiam Systems Pvt. Ltd, Bangalore
*/
#ifndef IXHEAACD_AAC_CONFIG_H
#define IXHEAACD_AAC_CONFIG_H

#define IA_XHEAAC_DEC_CONFIG_PARAM_PCM_WDSZ 0x0000
#define IA_XHEAAC_DEC_CONFIG_PARAM_SAMP_FREQ 0x0001
#define IA_XHEAAC_DEC_CONFIG_PARAM_NUM_CHANNELS 0x0002
#define IA_XHEAAC_DEC_CONFIG_PARAM_CHANNEL_MASK 0x0003
#define IA_XHEAAC_DEC_CONFIG_PARAM_CHANNEL_MODE 0x0004
#define IA_XHEAAC_DEC_CONFIG_PARAM_SBR_MODE 0x0005
#define IA_XHEAAC_DEC_CONFIG_PARAM_DRC_EFFECT_TYPE 0x0006
#define IA_XHEAAC_DEC_CONFIG_PARAM_DRC_TARGET_LOUDNESS 0x0007
#define IA_XHEAAC_DEC_CONFIG_PARAM_DRC_LOUD_NORM 0x0008

#define IA_XHEAAC_DEC_CONFIG_PARAM_DOWNMIX 0x0009
#define IA_XHEAAC_DEC_CONFIG_PARAM_TOSTEREO 0x000A
#define IA_XHEAAC_DEC_CONFIG_PARAM_DSAMPLE 0x000B
#define IA_XHEAAC_DEC_CONFIG_PARAM_MP4FLAG 0x000C
#define IA_XHEAAC_DEC_CONFIG_PARAM_MAX_CHANNEL 0x000D
#define IA_XHEAAC_DEC_CONFIG_PARAM_COUP_CHANNEL 0x000E
#define IA_XHEAAC_DEC_CONFIG_PARAM_DOWNMIX_STEREO 0x000F
#define IA_XHEAAC_DEC_CONFIG_DISABLE_SYNC 0x0010
#define IA_XHEAAC_DEC_CONFIG_PARAM_AUTO_SBR_UPSAMPLE 0x0011
#define IA_XHEAAC_DEC_CONFIG_PARAM_DRC_CUT 0x0012
#define IA_XHEAAC_DEC_CONFIG_PARAM_DRC_BOOST 0x0013
#define IA_XHEAAC_DEC_CONFIG_PARAM_DRC_TARGET_LEVEL 0x0014
#define IA_XHEAAC_DEC_CONFIG_PARAM_DRC_HEAVY_COMP 0x0015
#define IA_XHEAAC_DEC_CONFIG_PARAM_FRAMESIZE 0x0016
#define IA_XHEAAC_DEC_CONFIG_PARAM_LD_TESTING 0x0017
#define IA_XHEAAC_DEC_CONFIG_PARAM_HQ_ESBR 0x0018
#define IA_XHEAAC_DEC_CONFIG_PARAM_PS_ENABLE 0x0019
#define IA_XHEAAC_DEC_CONFIG_PARAM_AOT 0x001A
#define IA_XHEAAC_DEC_CONFIG_PARAM_PEAK_LIMITER 0x001B
#define IA_XHEAAC_DEC_CONFIG_PARAM_FRAMELENGTH_FLAG 0x001C
#define IA_XHEAAC_DEC_CONFIG_ERROR_CONCEALMENT 0x001D

#define IA_ENHAACPLUS_DEC_CONFIG_EXT_ELE_PTR 0x001E
#define IA_ENHAACPLUS_DEC_CONFIG_EXT_ELE_BUF_SIZES 0x001F
#define IA_ENHAACPLUS_DEC_CONFIG_NUM_ELE 0x0020
#define IA_ENHAACPLUS_DEC_CONFIG_NUM_CONFIG_EXT 0x0021
#define IA_ENHAACPLUS_DEC_CONFIG_GAIN_PAYLOAD_LEN 0x0022
#define IA_ENHAACPLUS_DEC_CONFIG_GAIN_PAYLOAD_BUF 0x0023
#define IA_ENHAACPLUS_DEC_CONFIG_GET_NUM_PRE_ROLL_FRAMES 0x0024
#define IA_ENHAACPLUS_DEC_DRC_IS_CONFIG_CHANGED 0x0025
#define IA_ENHAACPLUS_DEC_DRC_APPLY_CROSSFADE 0x0026
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DRC_ENABLE 0x0027

#define IA_XHEAAC_DEC_CONFIG_PARAM_ESBR 0x0028

#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_PCM_WDSZ IA_XHEAAC_DEC_CONFIG_PARAM_PCM_WDSZ
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_SAMP_FREQ IA_XHEAAC_DEC_CONFIG_PARAM_SAMP_FREQ
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_NUM_CHANNELS IA_XHEAAC_DEC_CONFIG_PARAM_NUM_CHANNELS
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_CHANNEL_MASK IA_XHEAAC_DEC_CONFIG_PARAM_CHANNEL_MASK
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_CHANNEL_MODE IA_XHEAAC_DEC_CONFIG_PARAM_CHANNEL_MODE
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_SBR_MODE IA_XHEAAC_DEC_CONFIG_PARAM_SBR_MODE
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DRC_EFFECT_TYPE \
        IA_XHEAAC_DEC_CONFIG_PARAM_DRC_EFFECT_TYPE
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DRC_TARGET_LOUDNESS \
        IA_XHEAAC_DEC_CONFIG_PARAM_DRC_TARGET_LOUDNESS
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DRC_LOUD_NORM IA_XHEAAC_DEC_CONFIG_PARAM_DRC_LOUD_NORM

#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DOWNMIX IA_XHEAAC_DEC_CONFIG_PARAM_DOWNMIX
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_TOSTEREO IA_XHEAAC_DEC_CONFIG_PARAM_TOSTEREO
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DSAMPLE IA_XHEAAC_DEC_CONFIG_PARAM_DSAMPLE
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_ISMP4 IA_XHEAAC_DEC_CONFIG_PARAM_MP4FLAG
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_MAX_CHANNEL IA_XHEAAC_DEC_CONFIG_PARAM_MAX_CHANNEL
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_COUP_CHANNEL IA_XHEAAC_DEC_CONFIG_PARAM_COUP_CHANNEL
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DOWNMIX_STEREO IA_XHEAAC_DEC_CONFIG_PARAM_DOWNMIX_STEREO
#define IA_ENHAACPLUS_DEC_CONFIG_DISABLE_SYNC IA_XHEAAC_DEC_CONFIG_DISABLE_SYNC
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_AUTO_SBR_UPSAMPLE \
        IA_XHEAAC_DEC_CONFIG_PARAM_AUTO_SBR_UPSAMPLE
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DRC_CUT IA_XHEAAC_DEC_CONFIG_PARAM_DRC_CUT
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DRC_BOOST IA_XHEAAC_DEC_CONFIG_PARAM_DRC_BOOST
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DRC_TARGET_LEVEL \
        IA_XHEAAC_DEC_CONFIG_PARAM_DRC_TARGET_LEVEL
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_DRC_HEAVY_COMP IA_XHEAAC_DEC_CONFIG_PARAM_DRC_HEAVY_COMP
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_FRAMESIZE IA_XHEAAC_DEC_CONFIG_PARAM_FRAMESIZE
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_LD_TESTING IA_XHEAAC_DEC_CONFIG_PARAM_LD_TESTING
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_HQ_ESBR IA_XHEAAC_DEC_CONFIG_PARAM_HQ_ESBR
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_PS_ENABLE IA_XHEAAC_DEC_CONFIG_PARAM_PS_ENABLE
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_AOT IA_XHEAAC_DEC_CONFIG_PARAM_AOT
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_PEAK_LIMITER IA_XHEAAC_DEC_CONFIG_PARAM_PEAK_LIMITER
#define IA_ENHAACPLUS_DEC_CONFIG_PARAM_FRAMELENGTH_FLAG \
        IA_XHEAAC_DEC_CONFIG_PARAM_FRAMELENGTH_FLAG

#define IA_ENHAACPLUS_DEC_DRC_EFFECT_TYPE IA_XHEAAC_DEC_CONFIG_PARAM_DRC_EFFECT_TYPE
#define IA_ENHAACPLUS_DEC_DRC_TARGET_LOUDNESS IA_XHEAAC_DEC_CONFIG_PARAM_DRC_TARGET_LOUDNESS

#endif /* IXHEAACD_AAC_CONFIG_H */
